#ifndef CON_AWF1MATC_H
#define CON_AWF1MATC_H

#include "genfile.h"

/**
   This class defines model for water flow in soils (deformable porous medium)
*/

class con_awf1matc
{
 public:
  con_awf1matc();    //constructor
  ~con_awf1matc();   //destructor

  void read(XFILE *in);
  void print(FILE *out);

  void rhs_volume (matrix &d,long ri,long ci,long ipp);
  void rhs1d1 (matrix &d,long ri,long ci,long ipp);
  void rhs2d1 (matrix &d,long ri,long ci,long ipp);
  void rhs3d1 (matrix &d,long ri,long ci,long ipp);

  double get_sw(double pw);
  double get_phi();
  double get_rhos();

  double get_kuw(double pw);
  double get_kwu(double pw);

  double get_capuw(double pw);
  double get_capwu(double pw);

  double get_fu1(double pw);

  double nu;

 private:
  
  waterflowmechtype model_type;
  double alpha,phi0,rhos;
  double rhow;
};  

#endif
